package xmlrpc;

import java.net.InetAddress;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.apache.xmlrpc.client.XmlRpcClient;
import org.apache.xmlrpc.client.XmlRpcClientConfigImpl;
import org.apache.xmlrpc.client.XmlRpcSunHttpTransportFactory;


public class Client {
    public static void main(String[] args) throws Exception {
        // vytvoreni konfigurace pro klienta
        XmlRpcClientConfigImpl config = new XmlRpcClientConfigImpl();
        InetAddress addr = InetAddress.getLocalHost();
        config.setServerURL(new URL("http://"+addr.getHostAddress()+":8080")); // nastaveni adresy serveru
        config.setEnabledForExtensions(false);		// true -> pridani extensions - odkloneni od standardu!
        config.setConnectionTimeout(60 * 1000);		// nastaveni timeoutu
        config.setReplyTimeout(60 * 1000);			// nastaveni reply timeoutu
        //vytvoreni klienta
        XmlRpcClient client = new XmlRpcClient();
      
        // vytvoreni trasportni casti - vyuziva java.net.URLConnection
        client.setTransportFactory(new XmlRpcSunHttpTransportFactory(client));
        //client.setTransportFactory(new XmlRpcCommonsTransportFactory(client)); // Jakarta Common HttpClient - vyzaduje commons-httpclient-???.jar
        
        // nastaveni (pripojeni) konfigurace
        client.setConfig(config);

        // vytvoreni vstupnich parametru
        Object[] params1 = new Object[]
            { new Integer(2), new Integer(3) };
        // vzdalene volani
        Integer result1 = (Integer) client.execute("xmlrpc.Calculator.add", params1);
        System.out.println("2 + 3 = " + result1);
        
        Integer result2 = (Integer) client.execute("xmlrpc.Calculator.sub", params1);
        System.out.println("2 - 3 = " + result2);
        
        // vstupni parametr pole
        List<Integer> indata = new ArrayList<Integer>();
        indata.add(10);
        indata.add(20);
        indata.add(30);
        indata.add(40);
        indata.add(50);
        
        Object[] params2 = new Object[] { indata };
        
        Integer result3 = (Integer) client.execute("xmlrpc.Calculator.addA", params2);
        System.out.println("Suma = " + result3);
        
        // vstupni i vystupni parametr pole
        Object[] result4 = (Object[]) client.execute("xmlrpc.Calculator.addOffset", params2);
        System.out.print("Offset: ");
        for (int i = 0;  i < result4.length;  i++) {
        	Integer num = (Integer) result4[i];
        	System.out.print(indata.get(i)+"->"+num+" ");
        }
        
        // vstupni parametr null
//        params1 = new Object[] { null };
//        Integer result5 = (Integer) client.execute("xmlrpc.Calculator.getCount", params1);
//        System.out.println("Count: " + result5);
    }
}






