package xmlrpc;

import xmlrpc.Calculator;

import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;

import org.apache.xmlrpc.client.XmlRpcClient;
import org.apache.xmlrpc.client.XmlRpcClientConfigImpl;
import org.apache.xmlrpc.client.util.ClientFactory;

public class ProxyClient {
	public static void main(String[] args) {
		try {
			// nastaveni konfigurace
			XmlRpcClientConfigImpl config = new XmlRpcClientConfigImpl();
			InetAddress addr = InetAddress.getLocalHost();
	        config.setServerURL(new URL("http://"+addr.getHostAddress()+":8080")); // nastaveni adresy serveru
	        config.setEnabledForExtensions(false);
	        // vytvoreni klienta
			XmlRpcClient client = new XmlRpcClient();
			client.setConfig(config);
			// vytvorime ClientFactory
			ClientFactory factory = new ClientFactory(client);
			// vytvorime proxy class
			Calculator adder = (Calculator) factory.newInstance(xmlrpc.Calculator.class);
			// a normalne pouzivame jako lokalni ...
			int sum = adder.add(2, 4);
			System.out.println("2 + 4 = "+sum);
			sum = adder.add(8, 4);
			System.out.println("8 + 4 = "+sum);
//			sum = adder.getCount();
//			System.out.println("Count: "+sum);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
	}

    
}
